const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const medicalExaminationService = require('./medicalExamination.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new medicalExamination
 * @param {Object} req.body - The medicalExamination data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created medicalExamination
 */
function create(req, res, next) {
    medicalExaminationService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all medicalExaminations
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of medicalExaminations
 */
function getAll(req, res, next) {
    medicalExaminationService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of medicalExamination objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of medicalExamination objects
 */
function option(req, res, next) {
    medicalExaminationService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of medicalExaminations matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of medicalExaminations
 */
function count(req, res, next) {
    medicalExaminationService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing medicalExamination
 * @param {number} req.params.id - The medicalExamination ID to be updated
 * @param {Object} req.body - The medicalExamination data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated medicalExamination
 */
function update(req, res, next) {
    medicalExaminationService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a medicalExamination
 * @param {number} req.params.id - The medicalExamination ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    medicalExaminationService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
